{$X+}unit Modul;{Version 2.00 vom 1.10.1997}
interface uses{$IFDEF DELPHI}WinTypes,{$ENDIF}Kern;
{73:}procedure geheNach(x,y:integer);{:73}{74:}
procedure zieheLinieNach(x,y,Farbe:integer);{:74}{75:}
procedure holeBildgroesse(var x1,y1,x2,y2:integer);{:75}{77:}
procedure dimensioniereFrequenz(fMin,fMax,x1,x2:real);{:77}{78:}
function fPlot(x:real):real;{:78}{79:}procedure liesReal(s:String;
var Rs:String;var r:real);procedure liesInteger(s:String;var IntS:String;
var i:integer);{:79}{80:}
procedure setzeBildschirmausschnitt(xb1,xb2,yb1,yb2:integer);
procedure dimensioniereBildschirm(xk1,xk2,yk1,yk2:real);{:80}{82:}
function xPlot(x:real):integer;function yPlot(y:real):integer;{:82}{83:}
function xWert(x:integer):real;function yWert(y:integer):real;{:83}{84:}
procedure zeichneXAchse(x0,y0,x1,x2,xTic,Format:real;xText:String;
lFarbe,tFarbe:integer);{:84}{85:}
procedure zeichneYAchse(x0,y0,y1,y2,yTic,Format:real;yText:String;
lFarbe,tFarbe:integer);{:85}{87:}
type Funktion=function(var t:real):real;
procedure Plot2d(plx1,plx2,ply1,ply2:integer;xMin,xMax,yMin,yMax:real;
zeichneAchsen:boolean;x0,y0:real;x1,x2,xTic,xFormat:real;xText:String;
y1,y2,yTic,yFormat:real;yText:String;lFarbe,tFarbe,fFarbe:integer;
fx,fy:Funktion;tmin,tMax,dt:real;Linienzug:boolean);{:87}{88:}
function id(var x:real):real;{:88}{90:}
procedure setze3dBildschirmausschnitt(nx,ny,nz,x3d0,y3d0:integer);
procedure dimensioniere3dBildschirm(xMin,xMax,yMin,yMax,zMin,zMax,phiz,
phix:real);procedure berechnexy3dPlot(x,y,z:real;var x3dp,y3dp:integer);
procedure zeichne3dXAchse(x0,y0,z0,y1,y2,x1,x2,xTic,xFormat:real;
xText:String;lFarbe,tFarbe:integer);
procedure zeichne3dYAchse(x0,y0,z0,x1,x2,y1,y2,yTic,yFormat:real;
yText:String;lFarbe,tFarbe:integer);
procedure zeichne3dZAchse(x0,y0,z0,y1,y2,z1,z2,zTic,zFormat:real;
zText:String;lFarbe,tFarbe:integer);
procedure Plot3d(nx,ny,nz,x3dm,y3dm:integer;
xMin,xMax,yMin,yMax,zMin,zMax,phiz,phix:real;zeichneAchsen:boolean;
x0,y0,z0:real;x1,x2,xTic,xFormat:real;xText:String;
y1,y2,yTic,yFormat:real;yText:String;z1,z2,zTic,zFormat:real;
zText:String;lFarbe,tFarbe,fFarbe:integer;fx,fy,fz:Funktion;
tmin,tMax,dt:real;
Linienzug,xyProjektion,yzProjektion,xzProjektion:boolean);{:90}{92:}
type Funktionxy=function(x,y:real):real;
procedure zeichneFxy(nx,ny,nz,x3d0,y3d0:integer;
xMin,xMax,yMin,yMax,zMin,zMax,phi1,phi2:real;dx,dy:real;fn:Funktionxy;
Beleuchtung,Umrandung:boolean;xl,yl,zl:real;yEnde:real;
var yAbbruch:real;var abgebrochen:boolean);{:92}{95:}const Dimension=410;
type Zustand=array[0..Dimension]of real;{:95}{96:}
type AbbildungsTyp=procedure(z0:Zustand;var z1:Zustand;Zaehler:integer);
{:96}{97:}type AuswahlArray=array[1..Dimension]of integer;{:97}{98:}
const maxAbbruch=10;type Abbruchbedingung=function(z0:Zustand;
c:integer):boolean;AbbruchArray=array[1..maxAbbruch]of Abbruchbedingung;
{:98}{99:}const maxHelligkeit={$IFDEF DELPHI}255{$ELSE}16{$ENDIF};
type FarbTyp=0..maxHelligkeit;FarbArray=array[1..maxAbbruch]of FarbTyp;
{:99}{100:}type ZeilenProzedur=procedure;{:100}{101:}
{$F+}function dummyAbbruch(z:Zustand;c:integer):boolean;
procedure dummyProzedur;{$F-}{:101}{102:}
procedure zeichneEinzugsgebiete(px1,px2,py1,py2:integer;
xMin,xMax,yMin,yMax:real;zeichneAchsen:boolean;x0,y0:real;
x1,x2,xTic,xFormat:real;xText:String;y1,y2,yTic,yFormat:real;
yText:String;lFarbe,tFarbe:integer;Abbildung:AbbildungsTyp;
Abbruch:AbbruchArray;Auswahl:AuswahlArray;ZeilenProz:ZeilenProzedur;
z0:Zustand;Farbe:FarbArray;AnzDim,AnzAbbr,Nummer:integer;
schwarzweiss:boolean;Endzeile:integer;var Abbruchzeile:integer;
var abgebrochen:boolean);{:102}{111:}type Zuwachs=Zustand;
AendType=procedure(z:Zustand;var zuw:Zuwachs);
procedure Ganzschritt(f:integer;delta:real;var z:Zustand;var t:real;
var tZ:LongInt;Aenderung:AendType);procedure RungeKutta(f:integer;
delta:real;var z:Zustand;var t:real;var tZ:LongInt;Aenderung:AendType);
{:111}{113:}function Nullstelle(f,f1:Funktion;Anfang,Genauigkeit:real;
maxIter:integer):real;{:113}{114:}const maxSpeicherwerte=4098;
type SpeicherFeld=array[0..maxSpeicherwerte-1]of real;
procedure Fouriertransformation(var F:SpeicherFeld;deltat:real;
var N:integer;var fMin,fMax,Maximum:real);{:114}implementation{216:}
var xp,yp:integer;procedure geheNach(x,y:integer);begin xp:=x;yp:=y end;
procedure zieheLinieNach(x,y,Farbe:integer);
begin zeichneLinie(xp,yp,x,y,Farbe);xp:=x;yp:=y end;
procedure holeBildgroesse(var x1,y1,x2,y2:integer);var i,j:integer;
begin x1:=xm;x2:=0;y1:=ym;y2:=0;i:=0;
while(x1=xm)and(i<xm)do begin for j:=0 to ym do if holePunkt(i,j)>0 then
x1:=i;Inc(i)end;j:=0;
while(y1=ym)and(j<ym)do begin for i:=0 to xm do if holePunkt(i,j)>0 then
y1:=j;Inc(j)end;i:=xm;
while(x2=0)and(i>0)do begin for j:=0 to ym do if holePunkt(i,j)>0 then
x2:=i;Dec(i)end;j:=ym;
while(y2=0)and(j>0)do begin for i:=0 to xm do if holePunkt(i,j)>0 then
y2:=j;Dec(j)end;end;{:216}{217:}var pf1,pf2,xfMin,xfMax,fFaktor:real;
procedure dimensioniereFrequenz(fMin,fMax,x1,x2:real);
begin pf1:=ln(fMin);pf2:=ln(fMax);xfMin:=x1;xfMax:=x2;
fFaktor:=(pf2-pf1)/(xfMax-xfMin);end;{:217}{218:}
function fPlot(x:real):real;begin fPlot:=exp(pf1+(x-xfMin)*fFaktor)end;
{:218}{219:}procedure liesReal(s:String;var Rs:String;var r:real);
var Code,p:integer;s1:String;begin repeat liesString(s,Rs);s1:=Rs;
p:=Pos(',',s1);while p>0 do begin s1[p]:='.';p:=Pos(',',s1);end;
wandleStringInReal(s1,r,Code);if Code<>0 then Write(Chr(7))until Code=0;
end;procedure liesInteger(s:String;var IntS:String;var i:integer);
var Code:integer;begin repeat liesString(s,IntS);
wandleStringInInteger(IntS,i,Code);
if Code<>0 then Write(Chr(7))until Code=0;end;{:219}{221:}
var px1,px2,py1,py2:integer;
procedure setzeBildschirmausschnitt(xb1,xb2,yb1,yb2:integer);
begin px1:=xb1;px2:=xb2;py1:=yb1;py2:=yb2 end;{:221}{222:}
var xMin,xMax,yMin,yMax,xFaktor,yFaktor:real;
procedure dimensioniereBildschirm(xk1,xk2,yk1,yk2:real);begin xMin:=xk1;
xMax:=xk2;yMin:=yk1;yMax:=yk2;xFaktor:=(px2-px1)/(xMax-xMin);
yFaktor:=(py2-py1)/(yMax-yMin);end;{:222}{223:}
function xPlot(x:real):integer;begin x:=px1+(x-xMin)*xFaktor;
if Abs(x)<maxint then xPlot:=Round(x)else xPlot:=maxint end;
function yPlot(y:real):integer;begin y:=py1+(yMax-y)*yFaktor;
if Abs(y)<maxint then yPlot:=Round(y)else yPlot:=maxint end;{:223}{224:}
function xWert(x:integer):real;begin xWert:=(x-px1)/xFaktor+xMin end;
function yWert(y:integer):real;begin yWert:=(py1-y)/yFaktor+yMax end;
{:224}{225:}procedure zeichneXAchse(x0,y0,x1,x2,xTic,Format:real;
xText:String;lFarbe,tFarbe:integer);var i,sign:real;
TicLaenge,xpos,ypos,n,(*l,vor,nach,*)hd,vd:integer;zahl:String;
begin hd:=horDir;vd:=verDir;
if xm>799 then TicLaenge:=10 else TicLaenge:=5;
if x1<x2 then sign:=1.0 else sign:=-1.0;
(*vor:=Trunc(Format);
nach:=Round(10*(Format-vor));
if nach>0 then l:=vor+nach+2 else l:=vor+nach+1;*)
zeichneLinie(xPlot(x1),yPlot(y0),xPlot(x2),yPlot(y0),lFarbe);i:=x0;n:=0;
while sign*(i-sign*xTic)>sign*x1 do begin i:=i-sign*xTic;n:=n-1 end;
ypos:=yPlot(y0)+TicLaenge;setzeTextausrichtung(1,2);
while sign*i<sign*x2 do begin zeichneLinie(xPlot(i),yPlot(y0),xPlot(i),
ypos,lFarbe);
if Format<>0 then if(n mod 2=0)and(n<>0)then begin wandleZahlInString(i,
Format,zahl);zeichneGrafstring(xPlot(i),ypos+zHoehe,zahl,tFarbe)end;
i:=i+sign*xTic;n:=n+1 end;xpos:=xPlot(x2);
ypos:=yPlot(y0)+2*TicLaenge+2*zHoehe;setzeTextausrichtung(2,2);
zeichneGrafstring(xpos,ypos,xText,tFarbe);
setzeTextausrichtung(hd,vd)end;{:225}{226:}
procedure zeichneYAchse(x0,y0,y1,y2,yTic,Format:real;yText:String;
lFarbe,tFarbe:integer);var i,sign:real;
TicLaenge,xpos,(*ypos,*)n,(*j,l,*)vor,nach,hd,vd:integer;zahl:String;
begin hd:=horDir;vd:=verDir;
if xm>799 then TicLaenge:=10 else TicLaenge:=5;
if y1<y2 then sign:=1.0 else sign:=-1.0;
vor:=Trunc(Format);
nach:=Round(10*(Format-vor));
(*if nach>0 then l:=vor+nach+2 else l:=vor+nach+1;*)
zeichneLinie(xPlot(x0),yPlot(y1),xPlot(x0),yPlot(y2),lFarbe);i:=y0;n:=0;
while sign*(i-sign*yTic)>sign*y1 do begin i:=i-sign*yTic;n:=n-1 end;
xpos:=xPlot(x0)-TicLaenge;setzeTextausrichtung(2,1);
while sign*i<sign*y2 do begin zeichneLinie(xpos,yPlot(i),xPlot(x0),yPlot
(i),lFarbe);
if Format<>0.0 then if(n mod 2=0)and(n<>0)then begin wandleZahlInString(
i,Format,zahl);
zeichneGrafstring(xpos-TicLaenge,yPlot(i),zahl,tFarbe)end;
i:=i+sign*yTic;n:=n+1 end;
xpos:=xPlot(x0)-2*TicLaenge-(vor+nach+3)*zBreite;
setzeTextausrichtung(2,2);
zeichneVertGrafstring(xpos,yPlot(y2),yText,tFarbe);
setzeTextausrichtung(hd,vd);end;{:226}{227:}
procedure Plot2d(plx1,plx2,ply1,ply2:integer;xMin,xMax,yMin,yMax:real;
zeichneAchsen:boolean;x0,y0:real;x1,x2,xTic,xFormat:real;xText:String;
y1,y2,yTic,yFormat:real;yText:String;lFarbe,tFarbe,fFarbe:integer;
fx,fy:Funktion;tmin,tMax,dt:real;Linienzug:boolean);var t,sgn:real;
begin if tMax>tmin then sgn:=1.0 else sgn:=-1.0;
setzeBildschirmausschnitt(plx1,plx2,ply1,ply2);
dimensioniereBildschirm(xMin,xMax,yMin,yMax);
if zeichneAchsen then begin zeichneXAchse(x0,y0,x1,x2,xTic,xFormat,xText
,lFarbe,tFarbe);
zeichneYAchse(x0,y0,y1,y2,yTic,yFormat,yText,lFarbe,tFarbe)end;t:=tmin;
if Linienzug then geheNach(xPlot(fx(t)),yPlot(fy(t)))else setzePunkt(
xPlot(fx(t)),yPlot(fy(t)),fFarbe);
while sgn*(t+dt)<=sgn*tMax do begin t:=t+dt;
if Linienzug then zieheLinieNach(xPlot(fx(t)),yPlot(fy(t)),fFarbe)else
setzePunkt(xPlot(fx(t)),yPlot(fy(t)),fFarbe)end end;{:227}{228:}
function id(var x:real):real;begin id:=x end;{:228}{229:}
var px13d,px23d,py13d,py23d,pz13d,pz23d,x3dm,y3dm:integer;
procedure setze3dBildschirmausschnitt(nx,ny,nz,x3d0,y3d0:integer);
begin x3dm:=x3d0;y3dm:=y3d0;px13d:=-nx div 2;px23d:=-px13d;
py13d:=-ny div 2;py23d:=-py13d;pz13d:=-nz div 2;pz23d:=-pz13d;end;{:229}
{230:}var x3dMin,x3dMax,y3dMin,y3dMax,z3dMin,z3dMax,x3dFaktor,y3dFaktor,
z3dFaktor:real;
sinphiz,cosphiz,sinphix,cosphix,sinphixsinphiz,sinphixcosphiz:real;
procedure dimensioniere3dBildschirm(xMin,xMax,yMin,yMax,zMin,zMax,phiz,
phix:real);const Grad=Pi/180.0;begin x3dMin:=xMin;x3dMax:=xMax;
y3dMin:=yMin;y3dMax:=yMax;z3dMin:=zMin;z3dMax:=zMax;
x3dFaktor:=(px23d-px13d)/(xMax-xMin);
y3dFaktor:=(py23d-py13d)/(yMax-yMin);
z3dFaktor:=(pz23d-pz13d)/(zMax-zMin);phiz:=phiz*Grad;phix:=phix*Grad;
sinphiz:=sin(phiz);cosphiz:=cos(phiz);sinphix:=sin(phix);
cosphix:=cos(phix);sinphixsinphiz:=sinphix*sinphiz;
sinphixcosphiz:=sinphix*cosphiz;end;{:230}{231:}
function x3dPlot(x:real):real;begin x3dPlot:=px13d+(x-x3dMin)*x3dFaktor;
end;function y3dPlot(y:real):real;
begin y3dPlot:=py13d+(y-y3dMin)*y3dFaktor;end;
function z3dPlot(z:real):real;begin z3dPlot:=pz13d+(z3dMax-z)*z3dFaktor;
end;{:231}{232:}procedure berechnexy3dPlot(x,y,z:real;
var x3dp,y3dp:integer);var xp,yp,zp:real;begin xp:=x3dPlot(x);
yp:=y3dPlot(y);zp:=z3dPlot(z);x3dp:=x3dm+Round(cosphiz*xp-sinphiz*yp);
y3dp:=y3dm+Round(sinphixsinphiz*xp+sinphixcosphiz*yp+cosphix*zp);end;
{:232}{233:}
procedure zeichne3dXAchse(x0,y0,z0,y1,y2,x1,x2,xTic,xFormat:real;
xText:String;lFarbe,tFarbe:integer);var i,sign:real;
n,l,vor,nach,x1p,y1p,x2p,y2p:integer;zahl:String;
begin if x1<x2 then sign:=1.0 else sign:=-1.0;vor:=Trunc(xFormat);
nach:=Round(10.0*(xFormat-vor));
if nach>0 then l:=vor+nach+2 else l:=vor+nach+1;
berechnexy3dPlot(x1,y0,z0,x1p,y1p);berechnexy3dPlot(x2,y0,z0,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);i:=x0;n:=0;
while sign*(i-sign*xTic)>sign*x1 do begin i:=i-sign*xTic;Dec(n)end;
while sign*i<sign*x2 do begin berechnexy3dPlot(i,y0,z0,x1p,y1p);
berechnexy3dPlot(i,y0-0.03*(y2-y1),z0,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);
if xFormat<>0 then if(n mod 5=0)and(n<>0)then begin wandleZahlInString(i
,xFormat,zahl);berechnexy3dPlot(i,y0-0.03*(y2-y1),z0,x1p,y1p);
zeichneGrafstring(x1p-(l*zBreite),y1p+Round(1.5*zHoehe),zahl,tFarbe)end;
i:=i+sign*xTic;Inc(n)end;berechnexy3dPlot(x2,y0,z0,x1p,y1p);
zeichneGrafstring(x1p-(l div 2)*zBreite,y1p+Round(1.5*zHoehe),xText,
tFarbe);end;{:233}{234:}
procedure zeichne3dYAchse(x0,y0,z0,x1,x2,y1,y2,yTic,yFormat:real;
yText:String;lFarbe,tFarbe:integer);var i,sign:real;
n,l,vor,nach,x1p,y1p,x2p,y2p:integer;zahl:String;
begin if y1<y2 then sign:=1.0 else sign:=-1.0;vor:=Trunc(yFormat);
nach:=Round(10.0*(yFormat-vor));
if nach>0 then l:=vor+nach+2 else l:=vor+nach+1;
berechnexy3dPlot(x0,y1,z0,x1p,y1p);berechnexy3dPlot(x0,y2,z0,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);i:=y0;n:=0;
while sign*(i-sign*yTic)>sign*y1 do begin i:=i-sign*yTic;Dec(n)end;
while sign*i<sign*y2 do begin berechnexy3dPlot(x0,i,z0,x1p,y1p);
berechnexy3dPlot(x0-0.03*(x2-x1),i,z0,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);
if yFormat<>0 then if(n mod 5=0)and(n<>0)then begin wandleZahlInString(i
,yFormat,zahl);berechnexy3dPlot(x0-0.03*(x2-x1),i,z0,x1p,y1p);
zeichneGrafstring(x1p-(l*zBreite),y1p-Round(0.5*zHoehe),zahl,tFarbe)end;
i:=i+sign*yTic;Inc(n)end;berechnexy3dPlot(x0,y2,z0,x1p,y1p);
zeichneGrafstring(x1p-(l div 2)*zBreite,y1p-Round(0.5*zHoehe),yText,
tFarbe);end;{:234}{235:}
procedure zeichne3dZAchse(x0,y0,z0,y1,y2,z1,z2,zTic,zFormat:real;
zText:String;lFarbe,tFarbe:integer);var i,sign:real;
n,l,vor,nach,x1p,y1p,x2p,y2p:integer;zahl:String;
begin if z1<z2 then sign:=1.0 else sign:=-1.0;vor:=Trunc(zFormat);
nach:=Round(10.0*(zFormat-vor));
if nach>0 then l:=vor+nach+2 else l:=vor+nach+1;
berechnexy3dPlot(x0,y0,z1,x1p,y1p);berechnexy3dPlot(x0,y0,z2,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);i:=z0;n:=0;
while sign*(i-sign*zTic)>sign*z1 do begin i:=i-sign*zTic;Dec(n)end;
while sign*i<sign*z2 do begin berechnexy3dPlot(x0,y0,i,x1p,y1p);
berechnexy3dPlot(x0,y0-0.02*(y2-y1),i,x2p,y2p);
zeichneLinie(x1p,y1p,x2p,y2p,lFarbe);
if zFormat<>0 then if(n mod 5=0)and(n<>0)then begin wandleZahlInString(i
,zFormat,zahl);berechnexy3dPlot(x0,y0-0.02*(y2-y1),i,x1p,y1p);
zeichneGrafstring(x1p-(l*zBreite),y1p-Round(0.5*zHoehe),zahl,tFarbe)end;
i:=i+sign*zTic;Inc(n)end;berechnexy3dPlot(x0,y0,z2,x1p,y1p);
zeichneGrafstring(x1p-(l div 2)*zBreite,y1p-Round(0.5*zHoehe),zText,
tFarbe);end;{:235}{236:}procedure Plot3d(nx,ny,nz,x3dm,y3dm:integer;
xMin,xMax,yMin,yMax,zMin,zMax,phiz,phix:real;zeichneAchsen:boolean;
x0,y0,z0:real;x1,x2,xTic,xFormat:real;xText:String;
y1,y2,yTic,yFormat:real;yText:String;z1,z2,zTic,zFormat:real;
zText:String;lFarbe,tFarbe,fFarbe:integer;fx,fy,fz:Funktion;
tmin,tMax,dt:real;
Linienzug,xyProjektion,yzProjektion,xzProjektion:boolean);
var xp,yp:integer;t,x,y,z:real;{237:}procedure Grafik3d;
var xp,yp:integer;begin berechnexy3dPlot(x,y,z,xp,yp);
if Linienzug then zieheLinieNach(xp,yp,fFarbe)else setzePunkt(xp,yp,
fFarbe);if xyProjektion then begin berechnexy3dPlot(x,y,z0,xp,yp);
setzePunkt(xp,yp,weiss);end;
if xzProjektion then begin berechnexy3dPlot(x,y0,z,xp,yp);
setzePunkt(xp,yp,weiss);end;
if yzProjektion then begin berechnexy3dPlot(x0,y,z,xp,yp);
setzePunkt(xp,yp,weiss);end;end;{:237}
begin setze3dBildschirmausschnitt(nx,ny,nz,x3dm,y3dm);
dimensioniere3dBildschirm(xMin,xMax,yMin,yMax,zMin,zMax,phiz,phix);
if zeichneAchsen then begin zeichne3dXAchse(x0,y0,z0,y1,y2,x1,x2,xTic,
xFormat,xText,lFarbe,tFarbe);
zeichne3dYAchse(x0,y0,z0,x1,x2,y1,y2,yTic,yFormat,yText,lFarbe,tFarbe);
zeichne3dZAchse(x0,y0,z0,y1,y2,z1,z2,zTic,zFormat,zText,lFarbe,tFarbe);
end;t:=tmin;x:=fx(t);y:=fy(t);z:=fz(t);berechnexy3dPlot(x,y,z,xp,yp);
if Linienzug then geheNach(xp,yp)else setzePunkt(xp,yp,fFarbe);
if xyProjektion then begin berechnexy3dPlot(x,y,z0,xp,yp);
setzePunkt(xp,yp,weiss);end;
if xzProjektion then begin berechnexy3dPlot(x,y0,z,xp,yp);
setzePunkt(xp,yp,weiss);end;
if yzProjektion then begin berechnexy3dPlot(x0,y,z,xp,yp);
setzePunkt(xp,yp,weiss);end;while t+dt<=tMax do begin t:=t+dt;x:=fx(t);
y:=fy(t);z:=fz(t);Grafik3d;end;end;{:236}{238:}
procedure zeichneFxy(nx,ny,nz,x3d0,y3d0:integer;
xMin,xMax,yMin,yMax,zMin,zMax,phi1,phi2:real;dx,dy:real;fn:Funktionxy;
Beleuchtung,Umrandung:boolean;xl,yl,zl:real;yEnde:real;
var yAbbruch:real;var abgebrochen:boolean);const Grad=Pi/180.0;
type Dreieck=array[0..2]of TPoint;
var i,iMax,xpl,ypl,Farbe,Taste:integer;
x,y,z1,z2,l,xf,yf,zf,xfzfdx,yfzfdy,xfyfdxdy:real;p:Dreieck;
xp,yp:array[0..1000]of integer;z:array[0..1000]of real;
zeichneRand:boolean;{:238}{239:}function fNr(nx,ny,nz:real):integer;
var r:real;begin r:=xl*nx+yl*ny+zl*nz;
if r>0.0 then begin r:=r*r/(nx*nx+ny*ny+nz*nz);
fNr:=Round(maxHelligkeit*r)end else fNr:=0;end;{:239}{240:}
begin if Beleuchtung then begin l:=sqrt(xl*xl+yl*yl+zl*zl);xl:=xl/l;
yl:=yl/l;zl:=zl/l;end;{:240}{241:}xf:=1.0/(xMax-xMin);
yf:=1.0/(yMax-yMin);zf:=1.0/(zMax-zMin);xfzfdx:=xf*zf*dx;
yfzfdy:=yf*zf*dy;xfyfdxdy:=xf*yf*dx*dy;
zeichneRand:=Umrandung or(not Beleuchtung);
if not Beleuchtung then begin{$IFDEF DELPHI}if zeichneRand then
setzeFuelltyp(maxHelligkeit,weiss,schwarz)else setzeFuelltyp(
maxHelligkeit,weiss,weiss){$ELSE}if zeichneRand then setzeFuelltyp(0,
weiss,weiss)else setzeFuelltyp(0,weiss,schwarz){$ENDIF}end;{:241}{242:}
setze3dBildschirmausschnitt(nx,ny,nz,x3d0,y3d0);
dimensioniere3dBildschirm(xMin,xMax,yMin,yMax,zMin,zMax,phi1,phi2);
{:242}{243:}y:=yAbbruch;x:=xMin;i:=0;repeat z[i]:=fn(x,y);
berechnexy3dPlot(x,y,z[i],xp[i],yp[i]);Inc(i);x:=x+dx until x>xMax;
iMax:=i-1;{:243}{244:}
while y>yEnde do begin if TasteGedrueckt then if Tastencode=Kern.Esc
then begin abgebrochen:=true;yAbbruch:=y;Exit;end;y:=y-dy;x:=xMin;
for i:=0 to iMax do begin
(*if i>0 then z1:=z2;*)
xpl:=xp[i];ypl:=yp[i];
z2:=z[i];z[i]:=fn(x,y);berechnexy3dPlot(x,y,z[i],xp[i],yp[i]);
if i>0 then begin p[0].x:=xp[i];p[0].y:=yp[i];
if Beleuchtung then begin Farbe:=fNr(yfzfdy*(z[i-1]-z[i]),xfzfdx*(z[i]-
z2),xfyfdxdy);
{$IFDEF DELPHI}if zeichneRand then setzeFuelltyp(Farbe,weiss,schwarz)
else setzeFuelltyp(Farbe,weiss,weiss){$ELSE}if zeichneRand then
setzeFuelltyp(Farbe,weiss,weiss)else setzeFuelltyp(Farbe,weiss,schwarz)
{$ENDIF}end{$IFDEF DELPHI}else if zeichneRand then setzeFuelltyp(
maxHelligkeit,weiss,schwarz)else setzeFuelltyp(maxHelligkeit,weiss,weiss
){$ENDIF};fuellePolygon(3,p)end;if i<iMax then begin p[0].x:=xpl;
p[0].y:=ypl;p[1].x:=xp[i+1];p[1].y:=yp[i+1];p[2].x:=xp[i];p[2].y:=yp[i];
if Beleuchtung then begin Farbe:=fNr(yfzfdy*(z2-z[i+1]),xfzfdx*(z[i]-z2)
,xfyfdxdy);
{$IFDEF DELPHI}if zeichneRand then setzeFuelltyp(Farbe,weiss,schwarz)
else setzeFuelltyp(Farbe,weiss,weiss){$ELSE}if zeichneRand then
setzeFuelltyp(Farbe,weiss,weiss)else setzeFuelltyp(Farbe,weiss,schwarz)
{$ENDIF}end{$IFDEF DELPHI}else if zeichneRand then setzeFuelltyp(
maxHelligkeit,weiss,schwarz)else setzeFuelltyp(maxHelligkeit,weiss,weiss
){$ENDIF};fuellePolygon(3,p)end;x:=x+dx end end;
setzeFuelltyp(maxHelligkeit,weiss,weiss);yAbbruch:=yEnde;
abgebrochen:=false end;{:244}{245:}function dummyAbbruch(z:Zustand;
c:integer):boolean;begin dummyAbbruch:=false end;
procedure dummyProzedur;begin end;{:245}{246:}
procedure zeichneEinzugsgebiete(px1,px2,py1,py2:integer;
xMin,xMax,yMin,yMax:real;zeichneAchsen:boolean;x0,y0:real;
x1,x2,xTic,xFormat:real;xText:String;y1,y2,yTic,yFormat:real;
yText:String;lFarbe,tFarbe:integer;Abbildung:AbbildungsTyp;
Abbruch:AbbruchArray;Auswahl:AuswahlArray;ZeilenProz:ZeilenProzedur;
z0:Zustand;Farbe:FarbArray;AnzDim,AnzAbbr,Nummer:integer;
schwarzweiss:boolean;Endzeile:integer;var Abbruchzeile:integer;
var abgebrochen:boolean);var dp,i,Taste:integer;{:246}{247:}
procedure zeichneRaster(dp:integer);const zeichneRand=0;
var px,py,Zaehler,FarbIndex,dim:integer;x,y:real;z:Zustand;Abb:boolean;
(*p:array[0..7]of integer;*)begin Taste:=0;py:=py1;{:247}{248:}
while py<Abbruchzeile do Inc(py,dp);
while(py<py2)and(Taste<>Kern.Esc)and(py<Endzeile)do begin Abbruchzeile:=
py;{:248}{249:}
if zeichneAchsen then begin zeichneXAchse(x0,y0,x1,x2,xTic,xFormat,xText
,lFarbe,tFarbe);
zeichneYAchse(x0,y0,y1,y2,yTic,yFormat,yText,lFarbe,tFarbe)end;
geheNach(px1,py1);zieheLinieNach(px2,py1,weiss);
zieheLinieNach(px2,py2,weiss);zieheLinieNach(px1,py2,weiss);
zieheLinieNach(px1,py1,weiss);ZeilenProz;y:=yWert(py+dp div 2);{:249}
{250:}px:=px1;while(px<px2)and(Taste<>Kern.Esc)do begin{:250}{251:}
if TasteGedrueckt then Taste:=Tastencode;x:=xWert(px+dp div 2);{:251}
{252:}z[Auswahl[1]]:=x;z[Auswahl[2]]:=y;{:252}{253:}dim:=2;
while AnzDim>dim do begin Inc(dim);z[Auswahl[dim]]:=z0[Auswahl[dim]];
end;setzeFuelltyp(maxHelligkeit,weiss,weiss);
fuelleRechteck(px,py,dp,dp);{:253}{254:}Zaehler:=0;
repeat Abbildung(z,z,Zaehler);FarbIndex:=0;repeat Inc(FarbIndex);
Abb:=Abbruch[FarbIndex](z,Zaehler);until Abb or(FarbIndex=AnzAbbr);
Inc(Zaehler)until Abb;
if(not schwarzweiss)and farbig then setzeFuelltyp(maxHelligkeit,Farbe[
FarbIndex],Farbe[FarbIndex])else setzeFuelltyp(Farbe[FarbIndex],weiss,
weiss);fuelleRechteck(px,py,dp,dp);px:=px+dp end;py:=py+dp end;
if(Taste<>Kern.Esc)and(py>=py2)then Abbruchzeile:=0 else if px>=px2 then
Abbruchzeile:=Abbruchzeile+dp;abgebrochen:=Taste=Esc;end;{:254}{255:}
begin px2:=px1+((px2-px1+1)div 16)*16-1;
py2:=py1+((py2-py1+1)div 16)*16-1;dp:=16;if Nummer>5 then Nummer:=5;
for i:=1 to Nummer-1 do dp:=dp div 2;
setzeBildschirmausschnitt(px1,px2,py1,py2);
dimensioniereBildschirm(xMin,xMax,yMin,yMax);zeichneRaster(dp);
if Abbruchzeile>0 then Exit;
if zeichneAchsen then begin zeichneXAchse(x0,y0,x1,x2,xTic,xFormat,xText
,lFarbe,tFarbe);
zeichneYAchse(x0,y0,y1,y2,yTic,yFormat,yText,lFarbe,tFarbe)end;
geheNach(px1,py1);zieheLinieNach(px2,py1,weiss);
zieheLinieNach(px2,py2,weiss);zieheLinieNach(px1,py2,weiss);
zieheLinieNach(px1,py1,weiss);end;{:255}{257:}
procedure Ganzschritt(f:integer;delta:real;var z:Zustand;var t:real;
var tZ:LongInt;Aenderung:AendType);var i:integer;zuw:Zuwachs;
begin Aenderung(z,zuw);for i:=1 to f do z[i]:=z[i]+zuw[i]*delta;
tZ:=tZ+2;t:=t+delta end;{:257}{258:}procedure RungeKutta(f:integer;
delta:real;var z:Zustand;var t:real;var tZ:LongInt;Aenderung:AendType);
var k1,k2,k3,k4:Zuwachs;z0:Zustand;i:integer;deltah,deltas:real;
begin deltah:=delta/2.0;deltas:=delta/6.0;z0:=z;Aenderung(z,k1);
tZ:=tZ+1;for i:=1 to f do z[i]:=z0[i]+k1[i]*deltah;Aenderung(z,k2);
for i:=1 to f do z[i]:=z0[i]+k2[i]*deltah;Aenderung(z,k3);tZ:=tZ+1;
for i:=1 to f do z[i]:=z0[i]+k3[i]*delta;Aenderung(z,k4);
for i:=1 to f do z[i]:=z0[i]+(k1[i]+k2[i]+k2[i]+k3[i]+k3[i]+k4[i])*
deltas;t:=t+delta end;{:258}{259:}function Nullstelle(f,f1:Funktion;
Anfang,Genauigkeit:real;maxIter:integer):real;var x0,x1:real;i:integer;
begin x0:=Anfang;i:=0;x1:=x0-f(x0)/f1(x0);
while(Abs(x0-x1)>Genauigkeit)and(i<maxIter)do begin Inc(i);x0:=x1;
x1:=x0-f(x0)/f1(x0)end;Nullstelle:=x1 end;{:259}{260:}
procedure Fouriertransformation(var F:SpeicherFeld;deltat:real;
var N:integer;var fMin,fMax,Maximum:real);var i:integer;
iFeld:^SpeicherFeld;{:260}{261:}
procedure FFT(var RealTeil,ImagTeil:SpeicherFeld;N:integer;
Flag:boolean);var a,tr,ti,wr,wi:real;mr,nn,l,istep,m,i,j:integer;
procedure Swap(var r1,r2:real);var r:real;begin r:=r1;r1:=r2;r2:=r end;
begin mr:=0;nn:=N-1;for m:=1 to nn do begin l:=N;l:=l div 2;
while mr+l>nn do l:=l div 2;mr:=(mr mod l)+l;
if mr>m then begin Swap(RealTeil[m],RealTeil[mr]);
Swap(ImagTeil[m],ImagTeil[mr])end end;l:=1;
while l<N do begin istep:=2*l;for m:=1 to l do begin a:=-Pi*(m-1)/l;
wr:=cos(a);if Flag then wi:=sin(a)else wi:=-sin(a);i:=m-1;repeat j:=i+l;
tr:=wr*RealTeil[j]-wi*ImagTeil[j];ti:=wr*ImagTeil[j]+wi*RealTeil[j];
RealTeil[j]:=RealTeil[i]-tr;ImagTeil[j]:=ImagTeil[i]-ti;
RealTeil[i]:=RealTeil[i]+tr;ImagTeil[i]:=ImagTeil[i]+ti;
i:=i+istep until i>=N end;l:=istep end;
if not Flag then for i:=0 to nn do begin RealTeil[i]:=RealTeil[i]/N;
ImagTeil[i]:=ImagTeil[i]/N end end;{:261}{262:}begin deltat:=deltat/N;
i:=1;while i<=N do i:=i*2;N:=i div 2;deltat:=deltat*N;fMin:=1.0/deltat;
fMax:=(N-1)*fMin;New(iFeld);if iFeld=NIL then Exit;
for i:=0 to N-1 do iFeld^[i]:=0.0;FFT(F,iFeld^,N,true);
F[0]:=sqrt(sqr(F[0])+sqr(iFeld^[0]));Maximum:=0.0;
for i:=1 to N-1 do begin F[i]:=sqrt(sqr(F[i])+sqr(iFeld^[i]));
if Maximum<F[i]then Maximum:=F[i]end;Dispose(iFeld)end;{:262}end.